#<profile4xi profile = "31"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "find4py.py">
#<abstract4xi abstract = "Finds required string patterns in Python programs"/>
#<refer4xi reference = "Studio4Xi"/>
#<note4xi note = "One of the most important and mostly used of tools to search Python source files!"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------


# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'find4py' ]
#"
#/>



# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from time4xi import time4xi    
from version4xi import VersionKB4Xi
from version4xi import ROOT4XI
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global kb2find
global max2find
global path2search4py
global rare2find
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
kb2find = {}
path2search4py = VersionKB4Xi['path2find4py'] 
#                                       ['studio']
#                                       ['multiprocessing4xi']
#                                       ['home2instance']  
rare2find = 'alaloydatatajonoa'
#"
#"/>

# -----------------------------------------------------------------------------------------------------
# SEARCH PATTERNS ** WARNING do NOT include the end tag, for example <refer4xi reference = "heap.py"/>
#                                                     would not find <refer4xi reference = "heap.py" />
#                 instead include ONLY the beginning:                <refer4xi reference = "heap.py"
# -----------------------------------------------------------------------------------------------------
#<define4xi definition = "    # KEEP THE SEARCH PATTERNS FOR FUTURE SOFTWARE DEVELOPMENT
                              # make sure you NEVER to trace self !
kb2find[1]='waterexploration'
kb2find[2]='Water Exploration'   
# kb2find[3]=rare2find 
# kb2find[4]=rare2find  
# kb2find[5]=rare2find  #[ACK]  make sure caller really wants memory address, otherwise .recv_bytes() should be called linke in hello_pipe4xi.py!
# kb2find[6]=rare2find  #[ACK]  <refer4xi reference = "pool.py"' 
# kb2find[7]=rare2find  #[ACK]  <refer4xi reference = "process.py"'
# kb2find[8]=rare2find  #[ACK]  <refer4xi reference = "queues.py"'
# kb2find[9]=rare2find  #[ACK]  <refer4xi reference = "reduction.py"'
# kb2find[10]=rare2find #[ACK]  <refer4xi reference = "sharedctypes.py"'
# kb2find[11]=rare2find #[ACK]  <refer4xi reference = "synchronize.py"'
# kb2find[12]=rare2find #[ACK]  <refer4xi reference = "util.py"' 
# kb2find[13]=rare2find #[ACK]  from _winapi import WAIT_OBJECT_0, WAIT_TIMEOUT, INFINITE'  
# kb2find[14]=rare2find #[ACK]  from _multiprocessing import win32' 
# kb2find[15]=rare2find #[ACK]  <refer4xi reference = "connection.py"/>' 
# kb2find[16]=rare2find #[ACK]  WAIT_OBJECT_0'
# kb2find[17]=rare2find #[ACK]  WAIT_TIMEOUT'
# kb2find[18]=rare2find #[ACK]  INFINITE'
# kb2find[19]=rare2find #[ACK]  reduce_pipe_connection
# kb2find[20]=rare2find #[ACK]  ResourceSharer4Xi
# kb2find[21]=rare2find #[ACK]  Barrier
# kb2find[22]=rare2find #[ACK]  BarrierProxy
# kb2find[23]=rare2find #[ACK]  PipeConnection
# kb2find[24]=rare2find #[ACK]  = Pipe4Xi
# kb2find[25]=rare2find #[ACK]  win32
# kb2find[26]=rare2find #[ACK]  _winapi.
# kb2find[27]=rare2find #[ACK]  <refer4xi reference = "connection.py"/>
# kb2find[28]=rare2find #[NACK] _subprocess. <-- these must be changes to call _winapi !!!!
# kb2find[29]=rare2find #[NACK]  <refer4xi reference = "forking.py"/> <-- check modules using this as base model  
# kb2find[30]=rare2find #[ACK]  ForkingPickler
# kb2find[31]=rare2find #[ACK]  Popen
# kb2find[32]=rare2find #[ACK]  _subprocess usage replaced
# kb2find[33]=rare2find #[ACK]  <refer4xi reference = "heap.py"
# kb2find[34]=rare2find #[ACK]  refer4xi reference = "managers.py
# kb2find[35]=rare2find #[ACK]  _Client check that _Client is called with right parameters and without 4Xi
# kb2find[36]=rare2find #[ACK]  raise - raised used too often in exceptions which prevents program to continue!
# kb2find[37]=rare2find #[ACK]  <refer4xi reference = "pool.py 
# kb2find[38]=rare2find #[ACK]  ThreadPool
# kb2find[39]=rare2find #[ACK]  (1e100)
# kb2find[40]=rare2find #[ACK]  refer4xi reference = "process.py' 
# kb2find[41]=rare2find #[ACK]  Process - checked class usage because of the new parameter daemon in __init__ method 
# kb2find[42]=rare2find #[ACK]  <refer4xi reference = "queues.py' 
# kb2find[43]=rare2find #[ACK]  Queue 
# kb2find[44]=rare2find #[ACK]  _multiprocessing. <-- may be ok (ex: sync and semaphore services) but might also be old API call to be replaced with _winapi. 
# kb2find[45]=rare2find #[NACK]  sentine might be method or variable with None value which might not be good to depict sentinel 
# kb2find[46]=rare2find #[NACK]  'raise'             #[NACK] make sure raise is not called if you want to continue! 
# kb2find[47]=rare2find #[NACK]  str(self)'         #[NACK] make sure you NEVER trace self !
# kb2find[48]=rare2find #[NACK]  str(self._handle)' #[NACK] check you trace handle only when it is available!
# kb2find[49]=rare2find #[NACK] 
# kb2find[50]=rare2find #[NACK] 
# kb2find[51]=rare2find #[NACK] 
# kb2find[52]=rare2find #[NACK] 
# kb2find[53]=rare2find #[NACK] 
# kb2find[54]=rare2find #[NACK] 
# kb2find[55]=rare2find #[NACK] 
# kb2find[56]=rare2find #[NACK] 
# kb2find[57]=rare2find #[NACK] 
# kb2find[58]=rare2find #[NACK] 
# kb2find[59]=rare2find #[NACK] 
# kb2find[60]=rare2find #[NACK] 
# kb2find[61]=rare2find #[NACK] 
# kb2find[62]=rare2find #[NACK] 
# kb2find[63]=rare2find #[NACK] 
# kb2find[64]=rare2find #[NACK] 
# kb2find[65]=rare2find #[NACK] 
# kb2find[66]=rare2find #[NACK] 
# kb2find[67]=rare2find #[NACK] 
# kb2find[68]=rare2find #[NACK] 
# kb2find[69]=rare2find #[NACK] 
# kb2find[70]=rare2find #[NACK] 


keys2find = kb2find.keys()
   
#"
#/>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "find4xi" usage = "
#   find anchor references
#"> 
# -------------------------------------------------------------------------------------------------
def find4py(icepFullName):
    global kb2find
    global keys2find
    
    iceName=os.path.splitext(icepFullName)
    #print ('icepFullName: ' + icepFullName)
    #print ('iceName[0]: ' + iceName[0])
    #print ('iceName[1]: ' + iceName[1])
    count2passed = 0
    count2found = 0
    if iceName[1] == '.py':
        iceInput = iceName[0]+'.py'
        input_file = open(iceInput)                                    # open file - due to recursion the module itself must be processed!
                                                                       
        while 1:
            try:
                l_in = input_file.readline()                               # process an input line
                if not l_in:
                    break                                                  # all lines have been read
                else:
                    for key2find in keys2find:
                        if kb2find[key2find] == rare2find:         
                            break                                          # nothing to be find anymore
                        else:    
                            i_xi2=str.find(l_in,kb2find[key2find])
                            if i_xi2 == -1:
                                count2passed = count2passed + 1                # no match
                            else: 
                                count2found = count2found + 1              # match
                                print ('FOUND: ' + icepFullName + ':')
                                # ..//..//..//..//studio4xi//python//3.3//src//build2scope4xi.py:
                                print ('-LINE: ' + l_in)
                                # <profile4xi profile = "31"/>
            except:
                pass
                                
        print ('icepFullName: ' + icepFullName)
        print ('count2passed: ')
        print (count2passed)
        print ('count2found: ')
        print (count2found)
        input_file.close()                                             # close file
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker">  
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            try:
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # pop next directory from stack
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # got a filename
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global path2search4py
    
    print('=' *70)
    print("Find4py [Rel 7.21] ", time4xi(), path2search4py)
    print('=' *70)
        
    
    for ice_file in DirectoryWalker(path2search4py):
        if os.path.isdir(ice_file):
            print ("Directory: " + ice_file + '\n')
        if os.path.isfile(ice_file):
            #print "Input file: " + ice_file + '\n'
            find4py(ice_file)
    
    print('=' *70)
    print("EOF Find4py  [Rel 7.21] for ", path2search4py, "  ", time4xi())
    print('=' *70)
#</function4xi>

    
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        

#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "

# Profile 17th of April 2010:
#kb2find[1]='_multiprocessing.PipeConnection'#  = Constant
#kb2find[2]=rare2find #while(
#ice_find_s3=rare2find #pass 
#ice_find_s4=rare2find # #<share4xi
#kb2find[5]=rare2find #= Client
#kb2find[6]=rare2find ##while(
#kb2find[7]=rare2find #def ace(self):
#kb2find[8]=rare2find #def reason(self):
#kb2find[9]=rare2find #def sense(self):
#kb2find[10]=rare2find #StepOriginal only is True
#kb2find[11]=rare2find #del !!!!!
#kb2find[12]=rare2find #raise !!!!!!!!!!!!!!!!!!!!!!!!!!!!
#kb2find[13]=rare2find #assert and accepted instead of asserted !!!!!!!!!!!!!!!!!
#kb2find[14]=rare2find #=None
#kb2find[15]=rare2find #address=None!!
#kb2find[16]=rare2find #authkey=None
#kb2find[17]=rare2find #= AuthenticationString4Xi
#kb2find[18]=rare2find #str(os.urandom(32))
#kb2find[19]=rare2find #authkey = 
#kb2find[20]=rare2find #os.urandom(32)
#kb2find[21]=rare2find #authkey=None
#kb2find[22]=rare2find #= AuthenticationString
#kb2find[23]=rare2find #ForkingPickler.register
#kb2find[24]=rare2find #ack2 <-- add nack2xi where needed !
#kb2find[25]=rare2find #authkey = 
#kb2find[26]=rare2find #AuthenticationString
#kb2find[27]=rare2find #os.urandom(32)
#kb2find[28]=rare2find #raise
#kb2find[29]=rare2find # -hit-by-
#kb2find[30]=rare2find # assert 
#kb2find[31]=rare2find # except:
#kb2find[32]=rare2find #dragonized !!!!!!!!
#kb2find[33]=rare2find #+ str(* <-- thes are too dangerous i.e. do NOT give pointer to str- function
#kb2find[34]=rare2find #sharing,share 
#kb2find[35]=rare2find #<type4xidict
#kb2find[36]=rare2find #address
#kb2find[37]=rare2find #ForkingPickler.register and ForkingPickler4Xi.register
#kb2find[38]=rare2find #raise SMOKE AWAY !!!! try-except-hit-assert
#kb2find[39]=rare2find #if sys.platform
#kb2find[40]=rare2find #pickle4xi given as parameter which is a bug!
#kb2find[41]=rare2find #from_address <-- to be solved; test_syncmanager4xi.py
#kb2find[42]=rare2find #raise
#kb2find[43]=rare2find #timeout
#kb2find[44]=rare2find #_address_to_local
#kb2find[45]=rare2find #_mutex
#kb2find[46]=rare2find #connection (c) !!!
#kb2find[47]=rare2find #self._Client
#kb2find[48]=rare2find #PipeClient
#kb2find[49]=rare2find #<-- timeout !!!
#kb2find[50]=rare2find #<-- args to check none is renamed !!!
#kb2find[51]=rare2find #_manager_server <-- to-be-explored
#kb2find[52]=rare2find #_current_process._identity 
#kb2find[53]=rare2find #current_process
#kb2find[54]=rare2find #_tls <-- thread local storage 
#kb2find[55]=rare2find ##<class4xi class = - to find modules with classes
#kb2find[56]=rare2find #MainThread
#kb2find[57]=rare2find #SomeOtherThread
#kb2find[58]=rare2find #SomeOtherProcess
#kb2find[59]=rare2find #debug4xi <-- delete these
#kb2find[60]=rare2find #<type4xi type = # <-- find all types in the system
#kb2find[61]=rare2find #'ZZZZZZZZ' # <-- unfinished tagging in modules
#kb2find[62]=rare2find #'zzzzzzzz'
#kb2find[63]=rare2find #'YYYYYYYY'
#kb2find[64]=rare2find #'yyyyyyyy'
#kb2find[65]=rare2find #'XXXXXXXX'
#kb2find[66]=rare2find #'xxxxxxxx'
#kb2find[67]=rare2find #borning and activated # <-- fix object borning messages;
#kb2find[68]=rare2find #StepOriginal
#kb2find[69]=rare2find #<class4xi class = "
#kb2find[70]=rare2find #expose-of-
#
# Profile 25th of March 2010:
#kb2find[1]='Value'#=None
#kb2find[2]='ValueProxyi' #
#kb2find[3]=rare2find #
#kb2find[4]=rare2find #
#kb2find[5]=rare2find #
#kb2find[6]=rare2find #
#kb2find[7]=rare2find #
#kb2find[8]=rare2find #
#kb2find[9]=rare2find #
#kb2find[10]=rare2find #
#kb2find[11]=rare2find #
#kb2find[12]=rare2find #raise !!!!!!!!!!!!!!!!!!!!!!!!!!!!
#kb2find[13]=rare2find #assert and accepted instead of asserted !!!!!!!!!!!!!!!!!
#kb2find[14]=rare2find #=None
#kb2find[15]=rare2find #address=None!!
#kb2find[16]=rare2find #authkey=None
#kb2find[17]=rare2find #= AuthenticationString4Xi
#kb2find[18]=rare2find #str(os.urandom(32))
#kb2find[19]=rare2find #authkey = 
#kb2find[20]=rare2find #os.urandom(32)
#kb2find[21]=rare2find #authkey=None
#kb2find[22]=rare2find #= AuthenticationString
#kb2find[23]=rare2find #ForkingPickler.register
#kb2find[24]=rare2find #ack2 <-- add nack2xi where needed !
#kb2find[25]=rare2find #authkey = 
#kb2find[26]=rare2find #AuthenticationString
#kb2find[27]=rare2find #os.urandom(32)
#kb2find[28]=rare2find #raise
#kb2find[29]=rare2find # -hit-by-
#kb2find[30]=rare2find # assert 
#kb2find[31]=rare2find # except:
#kb2find[32]=rare2find #dragonized !!!!!!!!
#kb2find[33]=rare2find #+ str(* <-- thes are too dangerous i.e. do NOT give pointer to str- function
#kb2find[34]=rare2find #sharing,share 
#kb2find[35]=rare2find #<type4xidict
#kb2find[36]=rare2find #address
#kb2find[37]=rare2find #ForkingPickler.register and ForkingPickler4Xi.register
#kb2find[38]=rare2find #raise SMOKE AWAY !!!! try-except-hit-assert
#kb2find[39]=rare2find #if sys.platform
#kb2find[40]=rare2find #pickle4xi given as parameter which is a bug!
#kb2find[41]=rare2find #from_address <-- to be solved; test_syncmanager4xi.py
#kb2find[42]=rare2find #raise
#kb2find[43]=rare2find #timeout
#kb2find[44]=rare2find #_address_to_local
#kb2find[45]=rare2find #_mutex
#kb2find[46]=rare2find #connection (c) !!!
#kb2find[47]=rare2find #self._Client
#kb2find[48]=rare2find #PipeClient
#kb2find[49]=rare2find #<-- timeout !!!
#kb2find[50]=rare2find #<-- args to check none is renamed !!!
#kb2find[51]=rare2find #_manager_server <-- to-be-explored
#kb2find[52]=rare2find #_current_process._identity 
#kb2find[53]=rare2find #current_process
#kb2find[54]=rare2find #_tls <-- thread local storage 
#kb2find[55]=rare2find ##<class4xi class = - to find modules with classes
#kb2find[56]=rare2find #MainThread
#kb2find[57]=rare2find #SomeOtherThread
#kb2find[58]=rare2find #SomeOtherProcess
#kb2find[59]=rare2find #debug4xi <-- delete these
#kb2find[60]=rare2find #<type4xi type = # <-- find all types in the system
#kb2find[61]=rare2find #'ZZZZZZZZ' # <-- unfinished tagging in modules
#kb2find[62]=rare2find #'zzzzzzzz'
#kb2find[63]=rare2find #'YYYYYYYY'
#kb2find[64]=rare2find #'yyyyyyyy'
#kb2find[65]=rare2find #'XXXXXXXX'
#kb2find[66]=rare2find #'xxxxxxxx'
#kb2find[67]=rare2find #borning and activated # <-- fix object borning messages;
#kb2find[68]=rare2find #StepOriginal
#kb2find[69]=rare2find #<class4xi class = "
#kb2find[70]=rare2find #expose-of-
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of find4py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
